#ifndef ENSEMBLE_H
#define ENSEMBLE_H

#include <ostream>

class Ensemble
{
  public:
    Ensemble();
    Ensemble(unsigned int taille, int * tableau);
    Ensemble(const Ensemble &);
    Ensemble & operator= (const Ensemble &);
    ~Ensemble();


    bool ajouter(int e);
    bool estPresent(int e) const;

    inline bool operator+= (int e) { return ajouter(e); }

    friend std::ostream & operator<<(std::ostream &, const Ensemble &);

  private:

    void ajusterCapacite(unsigned int capacite = 0);

    int * _tableau;
    unsigned int _taille;
    unsigned int _capacite;

    // Constante
    static const unsigned int GRANULARITE_CAPACITE = 10;
};

std::ostream & operator<<(std::ostream &, const Ensemble &);

#endif // ENSEMBLE_H
