#ifndef FRACTION_H
#define FRACTION_H

#include <ostream>
#include <istream>

class Fraction
{
  public:
    Fraction(int n = 0, int d = 1);
    Fraction(float f, int d = 100);
    Fraction(const Fraction & other);
    Fraction & operator= (const Fraction & other);
    ~Fraction();

    Fraction & simplifier();
    bool isSimplifiable() const;

    operator float() const { return float(_numerateur) / float(_denominateur); }
    Fraction operator+( const Fraction & other ) const;
    Fraction operator*( const Fraction & other ) const;

    static int pgcd( int a, int b );
    static unsigned int getCount() { return _count; }

    friend std::ostream & operator<<(std::ostream &, const Fraction &);
    friend std::istream & operator>>(std::istream &, Fraction &);

  protected:
  private:
    int _numerateur;
    int _denominateur;

    static unsigned int _count;
};

inline int Fraction::pgcd( int a, int b ) {
  while (b > 0) {
    int r = a % b;
    a = b;
    b = r;
  }
  return a;
}

std::ostream & operator<<(std::ostream &, const Fraction &);
std::istream & operator>>(std::istream &, Fraction &);

#endif // FRACTION_H
