#include "Fraction.h"
#include "Ensemble.h"

#include <iostream>
#include <cstdlib>

using namespace std;

void afficher1( const Fraction f ) {
  cout << f << endl;
}

void afficher2( const Fraction * f ) {
  cout << *f << endl;
}

void afficher3( const Fraction & f ) {
  cout << f << endl;
}

int main()
{
    cout << "Hello world!" << endl;

    Fraction f;
    Fraction g = 3;
    const Fraction h( 3, 4 );

    cout << f << " ; " << g << " ; " << h << endl;

    cout << "Afficher 1" << endl;
    afficher1(f);
    afficher1(h);
    cout << "Afficher 2" << endl;
    afficher2(&f);
    afficher2(&h);
    cout << "Afficher 3" << endl;
    afficher3(f);
    afficher3(h);
    cout << "Afficher --" << endl;

    cout << "Entrer une fraction (N / D): ";
    cin >> f;
    if (cin.good()) {
      cout << f << endl;
    }
    else {
      cout << "Ceci n'est pas une fraction..." << endl;
      cin.clear();
      cin.ignore(100,'\n');
    }

    f = g + h;
    cout << f << endl;
    f = g * h;
    cout << f << endl;

    Fraction i = f;
    i.simplifier();
    cout << i << endl;
    Fraction j( 12, 48 );
    cout << j << endl;
    j = i;
    cout << j << endl;

    Fraction k = 34.56789f;
    cout << k << endl;

    cout << "Il y a " << Fraction::getCount() << " Fractions" << endl;
    Fraction * l = new Fraction();
    cout << "Il y a " << Fraction::getCount() << " Fractions" << endl;
    delete l;
    cout << "Il y a " << Fraction::getCount() << " Fractions" << endl;


    // Test des Ensembles

    cout << endl;
    cout << "**********************" << endl;
    cout << "* TEST des Ensembles *" << endl;
    cout << "**********************" << endl;

    cout << std::boolalpha; // Affichage de "true" ou "false" pour le type "bool"

    Ensemble e;
    cout << e << endl;
    e.ajouter(3);
    e.ajouter(4);
    e += 6;
    e += 3;
    e += 5;
    cout << e << endl;
    cout << e.estPresent(2) << endl;
    cout << e.estPresent(3) << endl;

    srand(time(0));
    const int MAX_VALUE = 1000;
    for (unsigned int i=0; i<MAX_VALUE/10; i++) {
      e += rand() % MAX_VALUE;
    }
    cout << e << endl;

    for (unsigned int i=0; i<MAX_VALUE/10; i++) {
      int v = rand() % MAX_VALUE;
      cout << "Test: " << v << " " << e.estPresent(v) << endl;
    }

    return 0;
}
