#include "Fraction.h"

#include <iostream>

unsigned int Fraction::_count = 0;

Fraction::Fraction(int n, int d) :
    _numerateur(n), _denominateur(d)
{
  //ctor
  _count++;
  std::cerr << "Constructeur exact de Fraction " << *this << std::endl;
}

Fraction::Fraction(float f, int d) :
    _numerateur(int(f*float(d))), _denominateur(d)
{
  //ctor
  _count++;
  std::cerr << "Constructeur arrondi de Fraction " << *this << std::endl;
}

Fraction::Fraction(const Fraction & other) :
    _numerateur(other._numerateur),
    _denominateur(other._denominateur)
{
  // Copie
  _count++;
  std::cerr << "Constructeur de Copie de Fraction " << *this << std::endl;
}

Fraction & Fraction::operator= (const Fraction & other) {
  std::cerr << "Surcharge de l'Affectation de Fraction " << *this  << " avec Fraction " << other << std::endl;
  this->_numerateur = other._numerateur;
  this->_denominateur = other._denominateur;
  return *this;
}

Fraction::~Fraction()
{
  //dtor
  _count--;
  std::cerr << "Destructeur de Fraction " << *this << std::endl;
}

Fraction & Fraction::simplifier() {
  int d = Fraction::pgcd(_numerateur,_denominateur);
  _numerateur /= d;
  _denominateur /= d;
  return *this;
}

bool Fraction::isSimplifiable() const {
  return (Fraction::pgcd(_numerateur,_denominateur) > 1);
}

Fraction Fraction::operator+( const Fraction & other ) const {
  return Fraction( this->_numerateur * other._denominateur + other._numerateur * this->_denominateur, this->_denominateur * other._denominateur );
}

Fraction Fraction::operator*( const Fraction & other ) const {
  return Fraction  ( this->_numerateur * other._numerateur, this->_denominateur * other._denominateur );
}

std::ostream & operator<<(std::ostream & os, const Fraction & f) {
  os << f._numerateur << " / " << f._denominateur;
  return os;
}

std::istream & operator>>(std::istream & is, Fraction & f) {
  char sep;
  is >> f._numerateur >> sep >> f._denominateur;
  if (sep != '/') {
    is.setstate(std::ios::failbit);
  }
  return is;
}
